# This gimpfu.py code.
# For the life of me, I cannot find a way to override imported module's
# private functions (i.e _interact), so I am just pasting the whole thing in.
#
# If anyone can show me how this can be done better, please drop me an email.
#
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~ gimpfu start ~~~~~~~~~~~~~~~~~~~~~~~~~~
import string as _string
import math
import gimp
import gimpcolor
from gimpenums import *
pdb = gimp.pdb

import gettext
t = gettext.translation("gimp20-python", gimp.locale_directory, fallback=True)
_ = t.ugettext

class error(RuntimeError): pass
class CancelError(RuntimeError): pass

PF_INT8        = PDB_INT8
PF_INT16       = PDB_INT16
PF_INT32       = PDB_INT32
PF_INT         = PF_INT32
PF_FLOAT       = PDB_FLOAT
PF_STRING      = PDB_STRING
PF_VALUE       = PF_STRING
#PF_INT8ARRAY   = PDB_INT8ARRAY
#PF_INT16ARRAY  = PDB_INT16ARRAY
#PF_INT32ARRAY  = PDB_INT32ARRAY
#PF_INTARRAY    = PF_INT32ARRAY
#PF_FLOATARRAY  = PDB_FLOATARRAY
#PF_STRINGARRAY = PDB_STRINGARRAY
PF_COLOR       = PDB_COLOR
PF_COLOUR      = PF_COLOR
PF_ITEM        = PDB_ITEM
PF_DISPLAY     = PDB_DISPLAY
PF_IMAGE       = PDB_IMAGE
PF_LAYER       = PDB_LAYER
PF_CHANNEL     = PDB_CHANNEL
PF_DRAWABLE    = PDB_DRAWABLE
PF_VECTORS     = PDB_VECTORS
#PF_SELECTION   = PDB_SELECTION
#PF_BOUNDARY    = PDB_BOUNDARY
#PF_PATH        = PDB_PATH
#PF_STATUS      = PDB_STATUS

PF_TOGGLE      = 1000
PF_BOOL        = PF_TOGGLE
PF_SLIDER      = 1001
PF_SPINNER     = 1002
PF_ADJUSTMENT  = PF_SPINNER

PF_FONT        = 1003
PF_FILE        = 1004
PF_BRUSH       = 1005
PF_PATTERN     = 1006
PF_GRADIENT    = 1007
PF_RADIO       = 1008
PF_TEXT        = 1009
PF_PALETTE     = 1010
PF_FILENAME    = 1011
PF_DIRNAME     = 1012
PF_OPTION      = 1013

_type_mapping = {
    PF_INT8        : PDB_INT8,
    PF_INT16       : PDB_INT16,
    PF_INT32       : PDB_INT32,
    PF_FLOAT       : PDB_FLOAT,
    PF_STRING      : PDB_STRING,
    #PF_INT8ARRAY   : PDB_INT8ARRAY,
    #PF_INT16ARRAY  : PDB_INT16ARRAY,
    #PF_INT32ARRAY  : PDB_INT32ARRAY,
    #PF_FLOATARRAY  : PDB_FLOATARRAY,
    #PF_STRINGARRAY : PDB_STRINGARRAY,
    PF_COLOR       : PDB_COLOR,
    PF_ITEM        : PDB_ITEM,
    PF_DISPLAY     : PDB_DISPLAY,
    PF_IMAGE       : PDB_IMAGE,
    PF_LAYER       : PDB_LAYER,
    PF_CHANNEL     : PDB_CHANNEL,
    PF_DRAWABLE    : PDB_DRAWABLE,
    PF_VECTORS     : PDB_VECTORS,

    PF_TOGGLE      : PDB_INT32,
    PF_SLIDER      : PDB_FLOAT,
    PF_SPINNER     : PDB_INT32,

    PF_FONT        : PDB_STRING,
    PF_FILE        : PDB_STRING,
    PF_BRUSH       : PDB_STRING,
    PF_PATTERN     : PDB_STRING,
    PF_GRADIENT    : PDB_STRING,
    PF_RADIO       : PDB_STRING,
    PF_TEXT        : PDB_STRING,
    PF_PALETTE     : PDB_STRING,
    PF_FILENAME    : PDB_STRING,
    PF_DIRNAME     : PDB_STRING,
    PF_OPTION      : PDB_INT32,
}

_obj_mapping = {
    PF_INT8        : int,
    PF_INT16       : int,
    PF_INT32       : int,
    PF_FLOAT       : float,
    PF_STRING      : str,
    #PF_INT8ARRAY   : list,
    #PF_INT16ARRAY  : list,
    #PF_INT32ARRAY  : list,
    #PF_FLOATARRAY  : list,
    #PF_STRINGARRAY : list,
    PF_COLOR       : gimpcolor.RGB,
    PF_ITEM        : int,
    PF_DISPLAY     : gimp.Display,
    PF_IMAGE       : gimp.Image,
    PF_LAYER       : gimp.Layer,
    PF_CHANNEL     : gimp.Channel,
    PF_DRAWABLE    : gimp.Drawable,
    PF_VECTORS     : gimp.Vectors,

    PF_TOGGLE      : bool,
    PF_SLIDER      : float,
    PF_SPINNER     : int,

    PF_FONT        : str,
    PF_FILE        : str,
    PF_BRUSH       : str,
    PF_PATTERN     : str,
    PF_GRADIENT    : str,
    PF_RADIO       : str,
    PF_TEXT        : str,
    PF_PALETTE     : str,
    PF_FILENAME    : str,
    PF_DIRNAME     : str,
    PF_OPTION      : int,
}

_registered_plugins_ = {}

def register(proc_name, blurb, help, author, copyright, date, label,
             imagetypes, params, results, function,
             menu=None, domain=None, on_query=None, on_run=None):
    """This is called to register a new plug-in."""

    # First perform some sanity checks on the data
    def letterCheck(str):
        allowed = _string.letters + _string.digits + "_" + "-"
        for ch in str:
            if not ch in allowed:
                return 0
            else:
                return 1

    if not letterCheck(proc_name):
        raise error, "procedure name contains illegal characters"

    for ent in params:
        if len(ent) < 4:
            raise error, ("parameter definition must contain at least 4 "
                          "elements (%s given: %s)" % (len(ent), ent))

        if type(ent[0]) != int:
            raise error, "parameter types must be integers"

        if not letterCheck(ent[1]):
            raise error, "parameter name contains illegal characters"

    for ent in results:
        if len(ent) < 3:
            raise error, ("result definition must contain at least 3 elements "
                          "(%s given: %s)" % (len(ent), ent))

        if type(ent[0]) != type(42):
            raise error, "result types must be integers"

        if not letterCheck(ent[1]):
            raise error, "result name contains illegal characters"

    plugin_type = PLUGIN

    if (not proc_name.startswith("python-") and
        not proc_name.startswith("python_") and
        not proc_name.startswith("extension-") and
        not proc_name.startswith("extension_") and
        not proc_name.startswith("plug-in-") and
        not proc_name.startswith("plug_in_") and
        not proc_name.startswith("file-") and
        not proc_name.startswith("file_")):
           proc_name = "python-fu-" + proc_name

    # if menu is not given, derive it from label
    need_compat_params = False
    if menu is None and label:
        fields = label.split("/")
        if fields:
            label = fields.pop()
            menu = "/".join(fields)
            need_compat_params = True

            import warnings
            message = ("%s: passing the full menu path for the menu label is "
                       "deprecated, use the 'menu' parameter instead"
                       % (proc_name))
            warnings.warn(message, DeprecationWarning, 3)

        if need_compat_params and plugin_type == PLUGIN:
            file_params = [(PDB_STRING, "filename", "The name of the file", ""),
                           (PDB_STRING, "raw-filename", "The name of the file", "")]

            if menu is None:
                pass
            elif menu.startswith("<Load>"):
                params[0:0] = file_params
            elif menu.startswith("<Image>") or menu.startswith("<Save>"):
                params.insert(0, (PDB_IMAGE, "image", "Input image", None))
                params.insert(1, (PDB_DRAWABLE, "drawable", "Input drawable", None))
                if menu.startswith("<Save>"):
                    params[2:2] = file_params

    _registered_plugins_[proc_name] = (blurb, help, author, copyright,
                                       date, label, imagetypes,
                                       plugin_type, params, results,
                                       function, menu, domain,
                                       on_query, on_run)

def _query():
    for plugin in _registered_plugins_.keys():
        (blurb, help, author, copyright, date,
         label, imagetypes, plugin_type,
         params, results, function, menu, domain,
         on_query, on_run) = _registered_plugins_[plugin]

        def make_params(params):
            return [(_type_mapping[x[0]],
                     x[1],
                     _string.replace(x[2], "_", "")) for x in params]

        params = make_params(params)
        # add the run mode argument ...
        params.insert(0, (PDB_INT32, "run-mode",
                                     "The run mode { RUN-INTERACTIVE (0), RUN-NONINTERACTIVE (1) }"))

        results = make_params(results)

        if domain:
            try:
                (domain, locale_dir) = domain
                gimp.domain_register(domain, locale_dir)
            except ValueError:
                gimp.domain_register(domain)

        gimp.install_procedure(plugin, blurb, help, author, copyright,
                               date, label, imagetypes, plugin_type,
                               params, results)

        if menu:
            gimp.menu_register(plugin, menu)
        if on_query:
            on_query()

def _get_defaults(proc_name):
    import gimpshelf

    (blurb, help, author, copyright, date,
     label, imagetypes, plugin_type,
     params, results, function, menu, domain,
     on_query, on_run) = _registered_plugins_[proc_name]

    key = "python-fu-save--" + proc_name

    if gimpshelf.shelf.has_key(key):
        return gimpshelf.shelf[key]
    else:
        # return the default values
        return [x[3] for x in params]

def _set_defaults(proc_name, defaults):
    import gimpshelf

    key = "python-fu-save--" + proc_name
    gimpshelf.shelf[key] = defaults

def _interact(proc_name, start_params):
    (blurb, help, author, copyright, date,
     label, imagetypes, plugin_type,
     params, results, function, menu, domain,
     on_query, on_run) = _registered_plugins_[proc_name]

    def run_script(run_params):
        params = start_params + tuple(run_params)
        _set_defaults(proc_name, params)
        return apply(function, params)

    params = params[len(start_params):]

    # short circuit for no parameters ...
    if len(params) == 0:
         return run_script([])

    import pygtk
    pygtk.require('2.0')

    import gimpui
    import gtk
#    import pango

    defaults = _get_defaults(proc_name)
    defaults = defaults[len(start_params):]

    class EntryValueError(Exception):
        pass

    def warning_dialog(parent, primary, secondary=None):
        dlg = gtk.MessageDialog(parent, gtk.DIALOG_DESTROY_WITH_PARENT,
                                        gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE,
                                        primary)
        if secondary:
            dlg.format_secondary_text(secondary)
        dlg.run()
        dlg.destroy()

    def error_dialog(parent, proc_name):
        import sys, traceback

        exc_str = exc_only_str = _("Missing exception information")

        try:
            etype, value, tb = sys.exc_info()
            exc_str = "".join(traceback.format_exception(etype, value, tb))
            exc_only_str = "".join(traceback.format_exception_only(etype, value))
        finally:
            etype = value = tb = None

        title = _("An error occurred running %s") % proc_name
        dlg = gtk.MessageDialog(parent, gtk.DIALOG_DESTROY_WITH_PARENT,
                                        gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE,
                                        title)
        dlg.format_secondary_text(exc_only_str)

        alignment = gtk.Alignment(0.0, 0.0, 1.0, 1.0)
        alignment.set_padding(0, 0, 12, 12)
        dlg.vbox.pack_start(alignment)
        alignment.show()

        expander = gtk.Expander(_("_More Information"));
        expander.set_use_underline(True)
        expander.set_spacing(6)
        alignment.add(expander)
        expander.show()

        scrolled = gtk.ScrolledWindow()
        scrolled.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        scrolled.set_size_request(-1, 200)
        expander.add(scrolled)
        scrolled.show()


        label = gtk.Label(exc_str)
        label.set_alignment(0.0, 0.0)
        label.set_padding(6, 6)
        label.set_selectable(True)
        scrolled.add_with_viewport(label)
        label.show()

        def response(widget, id):
            widget.destroy()

        dlg.connect("response", response)
        dlg.set_resizable(True)
        dlg.show()

    # define a mapping of param types to edit objects ...
    class StringEntry(gtk.Entry):
        def __init__(self, default=""):
            gtk.Entry.__init__(self)
            self.set_text(str(default))

        def get_value(self):
            return self.get_text()

    class TextEntry(gtk.ScrolledWindow):
        def __init__ (self, default=""):
            gtk.ScrolledWindow.__init__(self)
            self.set_shadow_type(gtk.SHADOW_IN)

            self.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
            self.set_size_request(100, -1)

            self.view = gtk.TextView()
            self.add(self.view)
            self.view.show()

            self.buffer = self.view.get_buffer()

            self.set_value(str(default))

        def set_value(self, text):
            self.buffer.set_text(text)

        def get_value(self):
            return self.buffer.get_text(self.buffer.get_start_iter(),
                                        self.buffer.get_end_iter())

    class IntEntry(StringEntry):
        def get_value(self):
            try:
                return int(self.get_text())
            except ValueError, e:
                raise EntryValueError, e.args

    class FloatEntry(StringEntry):
            def get_value(self):
                try:
                    return float(self.get_text())
                except ValueError, e:
                    raise EntryValueError, e.args

#    class ArrayEntry(StringEntry):
#            def get_value(self):
#                return eval(self.get_text(), {}, {})


    def precision(step):
        # calculate a reasonable precision from a given step size
        if math.fabs(step) >= 1.0 or step == 0.0:
            digits = 0
        else:
            digits = abs(math.floor(math.log10(math.fabs(step))));
        if digits > 20:
            digits = 20
        return int(digits)

    class SliderEntry(gtk.HScale):
        # bounds is (upper, lower, step)
        def __init__(self, default=0, bounds=(0, 100, 5)):
            step = bounds[2]
            self.adj = gtk.Adjustment(default, bounds[0], bounds[1],
                                      step, 10 * step, 0)
            gtk.HScale.__init__(self, self.adj)
            self.set_digits(precision(step))

        def get_value(self):
            return self.adj.value

    class SpinnerEntry(gtk.SpinButton):
        # bounds is (upper, lower, step)
        def __init__(self, default=0, bounds=(0, 100, 5)):
            step = bounds[2]
            self.adj = gtk.Adjustment(default, bounds[0], bounds[1],
                                      step, 10 * step, 0)
            gtk.SpinButton.__init__(self, self.adj, step, precision(step))

    class ToggleEntry(gtk.ToggleButton):
        def __init__(self, default=0):
            gtk.ToggleButton.__init__(self)

            self.label = gtk.Label(_("No"))
            self.add(self.label)
            self.label.show()

            self.connect("toggled", self.changed)

            self.set_active(default)

        def changed(self, tog):
            if tog.get_active():
                self.label.set_text(_("Yes"))
            else:
                self.label.set_text(_("No"))

        def get_value(self):
            return self.get_active()

    class RadioEntry(gtk.VBox):
        def __init__(self, default=0, items=((_("Yes"), 1), (_("No"), 0))):
            gtk.VBox.__init__(self, homogeneous=False, spacing=2)

            button = None

            for (label, value) in items:
                button = gtk.RadioButton(button, label)
                self.pack_start(button)
                button.show()

                button.connect("toggled", self.changed, value)

                if value == default:
                    button.set_active(True)
                    self.active_value = value

        def changed(self, radio, value):
            if radio.get_active():
                self.active_value = value

        def get_value(self):
            return self.active_value

    class ComboEntry(gtk.ComboBox):
        def __init__(self, default=0, items=()):
            store = gtk.ListStore(str)
            for item in items:
                store.append([item])

            gtk.ComboBox.__init__(self, model=store)

            cell = gtk.CellRendererText()
            self.pack_start(cell)
            self.set_attributes(cell, text=0)

            self.set_active(default)

        def get_value(self):
            return self.get_active()

    def FileSelector(default=""):
        # FIXME: should this be os.path.separator?  If not, perhaps explain why?
        if default and default.endswith("/"):
            selector = DirnameSelector
            if default == "/": default = ""
        else:
            selector = FilenameSelector
        return selector(default)

    class FilenameSelector(gtk.FileChooserButton):
        def __init__(self, default="", save_mode=False):
            gtk.FileChooserButton.__init__(self,
                                           _("Python-Fu File Selection"))
            self.set_action(gtk.FILE_CHOOSER_ACTION_OPEN)
            if default:
                self.set_filename(default)

        def get_value(self):
            return self.get_filename()

    class DirnameSelector(gtk.FileChooserButton):
        def __init__(self, default=""):
            gtk.FileChooserButton.__init__(self,
                                           _("Python-Fu Folder Selection"))
            self.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
            if default:
                self.set_filename(default)

        def get_value(self):
            return self.get_filename()

    _edit_mapping = {
            PF_INT8        : IntEntry,
            PF_INT16       : IntEntry,
            PF_INT32       : IntEntry,
            PF_FLOAT       : FloatEntry,
            PF_STRING      : StringEntry,
            #PF_INT8ARRAY   : ArrayEntry,
            #PF_INT16ARRAY  : ArrayEntry,
            #PF_INT32ARRAY  : ArrayEntry,
            #PF_FLOATARRAY  : ArrayEntry,
            #PF_STRINGARRAY : ArrayEntry,
            PF_COLOR       : gimpui.ColorSelector,
            PF_ITEM        : IntEntry,  # should handle differently ...
            PF_IMAGE       : gimpui.ImageSelector,
            PF_LAYER       : gimpui.LayerSelector,
            PF_CHANNEL     : gimpui.ChannelSelector,
            PF_DRAWABLE    : gimpui.DrawableSelector,
            PF_VECTORS     : gimpui.VectorsSelector,

            PF_TOGGLE      : ToggleEntry,
            PF_SLIDER      : SliderEntry,
            PF_SPINNER     : SpinnerEntry,
            PF_RADIO       : RadioEntry,
            PF_OPTION      : ComboEntry,

            PF_FONT        : gimpui.FontSelector,
            PF_FILE        : FileSelector,
            PF_FILENAME    : FilenameSelector,
            PF_DIRNAME     : DirnameSelector,
            PF_BRUSH       : gimpui.BrushSelector,
            PF_PATTERN     : gimpui.PatternSelector,
            PF_GRADIENT    : gimpui.GradientSelector,
            PF_PALETTE     : gimpui.PaletteSelector,
            PF_TEXT        : TextEntry
    }

    if on_run:
        on_run()

    dialog = gimpui.Dialog(proc_name, "python-fu", None, 0, None, proc_name,
                           (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                            gtk.STOCK_OK, gtk.RESPONSE_OK))

    dialog.set_alternative_button_order((gtk.RESPONSE_OK, gtk.RESPONSE_CANCEL))

    dialog.set_transient()

    vbox = gtk.VBox(False, 12)
    vbox.set_border_width(12)
    dialog.vbox.pack_start(vbox)
    vbox.show()

    if blurb:
        if domain:
            try:
                (domain, locale_dir) = domain
                trans = gettext.translation(domain, locale_dir, fallback=True)
            except ValueError:
                trans = gettext.translation(domain, fallback=True)
            blurb = trans.ugettext(blurb)
        box = gimpui.HintBox(blurb)
        vbox.pack_start(box, expand=False)
        box.show()

    table = gtk.Table(len(params), 2, False)
    table.set_row_spacings(6)
    table.set_col_spacings(6)
    vbox.pack_start(table, expand=False)
    table.show()

    def response(dlg, id):
        if id == gtk.RESPONSE_OK:
            dlg.set_response_sensitive(gtk.RESPONSE_OK, False)
            dlg.set_response_sensitive(gtk.RESPONSE_CANCEL, False)

            params = []

            try:
                for wid in edit_wids:
                    params.append(wid.get_value())
            except EntryValueError:
                warning_dialog(dialog, _("Invalid input for '%s'") % wid.desc)
            else:
                try:
                    dialog.res = run_script(params)
                except Exception:
                    dlg.set_response_sensitive(gtk.RESPONSE_CANCEL, True)
                    error_dialog(dialog, proc_name)
                    raise

        gtk.main_quit()

    dialog.connect("response", response)

    edit_wids = []
    for i in range(len(params)):
        pf_type = params[i][0]
        name = params[i][1]
        desc = params[i][2]
        def_val = defaults[i]

        label = gtk.Label(desc)
        label.set_use_underline(True)
        label.set_alignment(0.0, 0.5)
        table.attach(label, 1, 2, i, i+1, xoptions=gtk.FILL)
        label.show()

        if pf_type in (PF_SPINNER, PF_SLIDER, PF_RADIO, PF_OPTION):
            wid = _edit_mapping[pf_type](def_val, params[i][4])
        else:
            wid = _edit_mapping[pf_type](def_val)

        label.set_mnemonic_widget(wid)

        table.attach(wid, 2,3, i,i+1, yoptions=0)

        if pf_type != PF_TEXT:
            wid.set_tooltip_text(desc)
        else:
            # Attach tip to TextView, not to ScrolledWindow
            wid.view.set_tooltip_text(desc)
        wid.show()

        wid.desc = desc
        edit_wids.append(wid)

    progress_vbox = gtk.VBox(False, 6)
    vbox.pack_end(progress_vbox, expand=False)
    progress_vbox.show()

    progress = gimpui.ProgressBar()
    progress_vbox.pack_start(progress)
    progress.show()

#    progress_label = gtk.Label()
#    progress_label.set_alignment(0.0, 0.5)
#    progress_label.set_ellipsize(pango.ELLIPSIZE_MIDDLE)

#    attrs = pango.AttrList()
#    attrs.insert(pango.AttrStyle(pango.STYLE_ITALIC, 0, -1))
#    progress_label.set_attributes(attrs)

#    progress_vbox.pack_start(progress_label)
#    progress_label.show()

    dialog.show()

    gtk.main()

    if hasattr(dialog, "res"):
        res = dialog.res
        dialog.destroy()
        return res
    else:
        dialog.destroy()
        raise CancelError

def _run(proc_name, params):
    run_mode = params[0]
    func = _registered_plugins_[proc_name][10]

    if run_mode == RUN_NONINTERACTIVE:
        return apply(func, params[1:])

    script_params = _registered_plugins_[proc_name][8]

    min_args = 0
    if len(params) > 1:
        for i in range(1, len(params)):
            param_type = _obj_mapping[script_params[i - 1][0]]
            if not isinstance(params[i], param_type):
                break

        min_args = i

    if len(script_params) > min_args:
        start_params = params[:min_args + 1]

        if run_mode == RUN_WITH_LAST_VALS:
            default_params = _get_defaults(proc_name)
            params = start_params + default_params[min_args:]
        else:
            params = start_params
    else:
       run_mode = RUN_NONINTERACTIVE

    if run_mode == RUN_INTERACTIVE:
        try:
            res = _interact(proc_name, params[1:])
        except CancelError:
            return
    else:
        res = apply(func, params[1:])

    gimp.displays_flush()

    return res

def main():
    """This should be called after registering the plug-in."""
    gimp.main(None, None, _query, _run)

def fail(msg):
    """Display an error message and quit"""
    gimp.message(msg)
    raise error, msg

def N_(message):
    return message
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~ gimpfu end ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Dev Notes:
#
# This is a modified gimpfu._interact function.
# This is to accomodate custom widget placement and functinality
#

def _interact(proc_name, start_params):
    (blurb, help, author, copyright, date,
     label, imagetypes, plugin_type,
     params, results, function, menu, domain,
     on_query, on_run) = _registered_plugins_[proc_name]

    def run_script(run_params):
        params = start_params + tuple(run_params)
        _set_defaults(proc_name, params)
        return apply(function, params)

    params = params[len(start_params):]

    # short circuit for no parameters ...
    if len(params) == 0:
         return run_script([])

    import pygtk
    pygtk.require('2.0')
    
    import gimpui
    import gtk
#    import pango

    defaults = _get_defaults(proc_name)
    defaults = defaults[len(start_params):]

    class EntryValueError(Exception):
        pass

    def warning_dialog(parent, primary, secondary=None):
        dlg = gtk.MessageDialog(parent, gtk.DIALOG_DESTROY_WITH_PARENT,
                                        gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE,
                                        primary)
        if secondary:
            dlg.format_secondary_text(secondary)
        dlg.run()
        dlg.destroy()

    def error_dialog(parent, proc_name):
        import sys, traceback

        exc_str = exc_only_str = _('Missing exception information')

        try:
            etype, value, tb = sys.exc_info()
            exc_str = ''.join(traceback.format_exception(etype, value, tb))
            exc_only_str = ''.join(traceback.format_exception_only(etype, value))
        finally:
            etype = value = tb = None

        title = _("An error occured running %s") % proc_name
        dlg = gtk.MessageDialog(parent, gtk.DIALOG_DESTROY_WITH_PARENT,
                                        gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE,
                                        title)
        dlg.format_secondary_text(exc_only_str)

        alignment = gtk.Alignment(0.0, 0.0, 1.0, 1.0)
        alignment.set_padding(0, 0, 12, 12)
        dlg.vbox.pack_start(alignment)
        alignment.show()

        expander = gtk.Expander(_("_More Information"));
        expander.set_use_underline(True)
        expander.set_spacing(6)
        alignment.add(expander)
        expander.show()

        scrolled = gtk.ScrolledWindow()
        scrolled.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        scrolled.set_size_request(-1, 200)
        expander.add(scrolled)
        scrolled.show()


        label = gtk.Label(exc_str)
        label.set_alignment(0.0, 0.0)
        label.set_padding(6, 6)
        label.set_selectable(True)
        scrolled.add_with_viewport(label)
        label.show()

        def response(widget, id):
            widget.destroy()

        dlg.connect("response", response)
        dlg.set_resizable(True)
        dlg.show()

    # define a mapping of param types to edit objects ...
    class StringEntry(gtk.Entry):
        def __init__(self, default=''):
            gtk.Entry.__init__(self)
            self.set_text(str(default))

        def get_value(self):
            return self.get_text()

    class TextEntry(gtk.ScrolledWindow):
        def __init__ (self, default=''):
            gtk.ScrolledWindow.__init__(self)
            self.set_shadow_type(gtk.SHADOW_IN)

            self.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
            self.set_size_request(100, 40)

            self.view = gtk.TextView()
            self.view.set_wrap_mode(gtk.WRAP_CHAR)
            self.add(self.view)
            self.view.show()

            self.buffer = self.view.get_buffer()

            self.set_value(str(default))

        def set_value(self, text):
            self.buffer.set_text(text)

        def get_value(self):
            return self.buffer.get_text(self.buffer.get_start_iter(),
                                        self.buffer.get_end_iter())
    class IntEntry(StringEntry):
        def get_value(self):
            try:
                return int(self.get_text())
            except ValueError, e:
                raise EntryValueError, e.args

    class FloatEntry(StringEntry):
            def get_value(self):
                try:
                    return float(self.get_text())
                except ValueError, e:
                    raise EntryValueError, e.args

#    class ArrayEntry(StringEntry):
#            def get_value(self):
#                return eval(self.get_text(), {}, {})


    def precision(step):
        # calculate a reasonable precision from a given step size
        if math.fabs(step) >= 1.0 or step == 0.0:
            digits = 0
        else:
            digits = abs(math.floor(math.log10(math.fabs(step))));
        if digits > 20:
            digits = 20
        return int(digits)

    class SliderEntry(gtk.HScale):
        # bounds is (upper, lower, step)
        def __init__(self, default=0, bounds=(0, 100, 5)):
            step = bounds[2]
            self.adj = gtk.Adjustment(default, bounds[0], bounds[1],
                                      step, 10 * step, 0)
            gtk.HScale.__init__(self, self.adj)
            self.set_digits(precision(step))

        def get_value(self):
            return self.adj.value

    class SpinnerEntry(gtk.SpinButton):
        # bounds is (upper, lower, step)
        def __init__(self, default=0, bounds=(0, 100, 5)):
            step = bounds[2]
            self.adj = gtk.Adjustment(default, bounds[0], bounds[1],
                                      step, 10 * step, 0)
            gtk.SpinButton.__init__(self, self.adj, step, precision(step))

    class ToggleEntry(gtk.ToggleButton):
        def __init__(self, default=0):
            gtk.ToggleButton.__init__(self)

            self.label = gtk.Label(_("No"))
            self.add(self.label)
            self.label.show()

            self.connect("toggled", self.changed)

            self.set_active(default)

        def changed(self, tog):
            if tog.get_active():
                self.label.set_text(_("Yes"))
            else:
                self.label.set_text(_("No"))

        def get_value(self):
            return self.get_active()

    class RadioEntry(gtk.VBox):
        def __init__(self, default=0, items=((_("Yes"), 1), (_("No"), 0))):
            gtk.VBox.__init__(self, homogeneous=False, spacing=2)

            button = None

            for (label, value) in items:
                button = gtk.RadioButton(button, label)
                self.pack_start(button)
                button.show()

                button.connect("toggled", self.changed, value)

                if value == default:
                    button.set_active(True)
                    self.active_value = value

        def changed(self, radio, value):
            if radio.get_active():
                self.active_value = value

        def get_value(self):
            return self.active_value

    class ComboEntry(gtk.ComboBox):
        def __init__(self, default=0, items=()):
            store = gtk.ListStore(str)
            for item in items:
                store.append([item])

            gtk.ComboBox.__init__(self, model=store)

            cell = gtk.CellRendererText()
            self.pack_start(cell)
            self.set_attributes(cell, text=0)

            self.set_active(default)

        def get_value(self):
            return self.get_active()

    def FileSelector(default=''):
       if default and default.endswith('/'):
           selector = DirnameSelector
           if default == '/': default = ''
       else:
           selector = FilenameSelector
       return selector(default)

    class FilenameSelector(gtk.FileChooserButton):
        def __init__(self, default='', save_mode=False):
            gtk.FileChooserButton.__init__(self,
                                           _("Python-Fu File Selection"))
            self.set_action(gtk.FILE_CHOOSER_ACTION_OPEN)
            if default:
                self.set_filename(default)

        def get_value(self):
            return self.get_filename()

    class DirnameSelector(gtk.FileChooserButton):
        def __init__(self, default=''):
            gtk.FileChooserButton.__init__(self,
                                           _("Python-Fu Folder Selection"))
            self.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
            if default:
                self.set_filename(default)
                
        def get_value(self):
            return self.get_filename()

    _edit_mapping = {
            PF_INT8        : IntEntry,
            PF_INT16       : IntEntry,
            PF_INT32       : IntEntry,
            PF_FLOAT       : FloatEntry,
            PF_STRING      : StringEntry,
            #PF_INT8ARRAY   : ArrayEntry,
            #PF_INT16ARRAY  : ArrayEntry,
            #PF_INT32ARRAY  : ArrayEntry,
            #PF_FLOATARRAY  : ArrayEntry,
            #PF_STRINGARRAY : ArrayEntry,
            PF_COLOR       : gimpui.ColorSelector,
            PF_ITEM     : IntEntry,  # should handle differently ...
            PF_IMAGE       : gimpui.ImageSelector,
            PF_LAYER       : gimpui.LayerSelector,
            PF_CHANNEL     : gimpui.ChannelSelector,
            PF_DRAWABLE    : gimpui.DrawableSelector,
            PF_VECTORS     : gimpui.VectorsSelector,

            PF_TOGGLE      : ToggleEntry,
            PF_SLIDER      : SliderEntry,
            PF_SPINNER     : SpinnerEntry,
            PF_RADIO       : RadioEntry,
            PF_OPTION      : ComboEntry,

            PF_FONT        : gimpui.FontSelector,
            PF_FILE        : FileSelector,
            PF_FILENAME    : FilenameSelector,
            PF_DIRNAME     : DirnameSelector,
            PF_BRUSH       : gimpui.BrushSelector,
            PF_PATTERN     : gimpui.PatternSelector,
            PF_GRADIENT    : gimpui.GradientSelector,
            PF_PALETTE     : gimpui.PaletteSelector,
            PF_TEXT        : TextEntry
    }

    if on_run:
        on_run()

    #tooltips = gtk.#tooltips()

    dialog = gimpui.Dialog(proc_name, 'python-fu', None, 0, None, proc_name,
                           (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                            gtk.STOCK_OK, gtk.RESPONSE_OK))

    dialog.set_alternative_button_order((gtk.RESPONSE_OK, gtk.RESPONSE_CANCEL))
    dialog.set_transient()

    vbox = gtk.VBox(False, 12)
    vbox.set_border_width(12)
    dialog.vbox.pack_start(vbox)
    vbox.show()

    if blurb:
        if domain:
            try:
                (domain, locale_dir) = domain
                trans = gettext.translation(domain, locale_dir, fallback=True)
            except ValueError:
                trans = gettext.translation(domain, fallback=True)
            blurb = trans.ugettext(blurb)
        box = gimpui.HintBox(blurb)
        vbox.pack_start(box, expand=False)
        #box.show()

    table = gtk.Table(len(params), 12, False)
    table.set_row_spacings(6)
    table.set_col_spacings(6)
    vbox.pack_start(table, expand=False)
    table.show()
    
    def response(dlg, id):
        if id == gtk.RESPONSE_OK:
            dlg.set_response_sensitive(gtk.RESPONSE_OK, False)
            dlg.set_response_sensitive(gtk.RESPONSE_CANCEL, False)

            params = []

            try:
                for wid in edit_wids:
                    params.append(wid.get_value())
            except EntryValueError:
                warning_dialog(dialog, _("Invalid input for '%s'") % wid.desc)
            else:
                try:
                    dialog.res = run_script(params)
                except Exception:
                    dlg.set_response_sensitive(gtk.RESPONSE_CANCEL, True)
                    error_dialog(dialog, proc_name)
                    raise

        gtk.main_quit()

    dialog.connect("response", response)
    edit_wids = []


# ADD WIDGETS MANUALLY

# Path Mode ---------------------
    pf_type = params[0][0]
    name = params[0][1]
    desc = params[0][2]
    def_val = defaults[0]
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 0, 1, 0, 1, xoptions=gtk.FILL)
    label.show()
    wid = _edit_mapping[pf_type](def_val, params[0][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 1, 3, 0, 1, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)
    
# X Limit ---------------------
    pf_type = params[1][0]
    name = params[1][1]
    desc = params[1][2]
    def_val = defaults[1]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 0, 1, 2, 3, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[1][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 1,2, 2, 3, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Y Limit ---------------------
    pf_type = params[2][0]
    name = params[2][1]
    desc = params[2][2]
    def_val = defaults[2]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 2, 3, 2, 3, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[2][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 3,4, 2, 3, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Num Points ---------------------
    pf_type = params[5][0]
    name = params[5][1]
    desc = params[5][2]
    def_val = defaults[5]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 4, 5, 2, 3, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[5][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 5, 6, 2, 3, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Random Seed ---------------------
    pf_type = params[7][0]
    name = params[7][1]
    desc = params[7][2]
    def_val = defaults[7]
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 6, 7, 2, 3, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[7][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 7, 8, 2, 3, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Scale ---------------------
    pf_type = params[8][0]
    name = params[8][1]
    desc = params[8][2]
    def_val = defaults[8]

    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 8, 9, 2, 3, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[8][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 9, 10, 2, 3, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)
    
# X Formula ---------------------
    pf_type = params[3][0]
    name = params[3][1]
    desc = params[3][2]
    def_val = defaults[3]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 0, 1, 5, 6, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val)
    label.set_mnemonic_widget(wid)
    table.attach(wid, 1, 10, 5, 6, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)
    
# Y Formula ---------------------
    pf_type = params[4][0]
    name = params[4][1]
    desc = params[4][2]
    def_val = defaults[4]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 0, 1, 6, 7, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val)
    label.set_mnemonic_widget(wid)
    table.attach(wid, 1, 10, 6, 7, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Paste Points ---------------------
    pf_type = params[6][0]
    name = params[6][1]
    desc = params[6][2]
    def_val = defaults[6]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 0, 1, 7, 8, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val)
    label.set_mnemonic_widget(wid)
    table.attach(wid, 1, 10, 7, 8, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Reverse ---------------------
    pf_type = params[9][0]
    name = params[9][1]
    desc = params[9][2]
    def_val = defaults[9]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 0, 1, 9, 10, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val)
    label.set_mnemonic_widget(wid)
    table.attach(wid, 1, 2, 9, 10, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Multiple ---------------------
    pf_type = params[10][0]
    name = params[10][1]
    desc = params[10][2]
    def_val = defaults[10]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 2, 3, 9, 10, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val)
    label.set_mnemonic_widget(wid)
    table.attach(wid, 3, 4, 9, 10, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Copies ---------------------
    pf_type = params[11][0]
    name = params[11][1]
    desc = params[11][2]
    def_val = defaults[11]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 0, 1, 10, 11, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[11][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 1, 2, 10, 11, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Offset X ---------------------
    pf_type = params[12][0]
    name = params[12][1]
    desc = params[12][2]
    def_val = defaults[12]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 2, 3, 10, 11, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[12][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 3, 4, 10, 11, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Offset Y ---------------------
    pf_type = params[13][0]
    name = params[13][1]
    desc = params[13][2]
    def_val = defaults[13]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 4, 5, 10, 11, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[13][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 5, 6, 10, 11, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Alternate ---------------------
    pf_type = params[14][0]
    name = params[14][1]
    desc = params[14][2]
    def_val = defaults[14]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 6, 7, 10, 11, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val)
    label.set_mnemonic_widget(wid)
    table.attach(wid, 7, 8, 10, 11, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Rotation ---------------------
    pf_type = params[15][0]
    name = params[15][1]
    desc = params[15][2]
    def_val = defaults[15]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 0, 1, 11, 12, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[15][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 1, 2, 11, 12, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Pivot Type ---------------------
    pf_type = params[16][0]
    name = params[16][1]
    desc = params[16][2]
    def_val = defaults[16]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 2, 3, 11, 12, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val,params[16][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 3, 4, 11, 12, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Pivot X ---------------------
    pf_type = params[17][0]
    name = params[17][1]
    desc = params[17][2]
    def_val = defaults[17]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 4, 5, 11, 12, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val,params[17][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 5, 6, 11, 12, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Pivot Y ---------------------
    pf_type = params[18][0]
    name = params[18][1]
    desc = params[18][2]
    def_val = defaults[18]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 6, 7, 11, 12, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val,params[18][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 7, 8, 11, 12, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Flip ---------------------
    pf_type = params[19][0]
    name = params[19][1]
    desc = params[19][2]
    def_val = defaults[19]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 0, 1, 12, 13, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val)
    label.set_mnemonic_widget(wid)
    table.attach(wid, 1, 2, 12, 13, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Flip Type ---------------------
    pf_type = params[20][0]
    name = params[20][1]
    desc = params[20][2]
    def_val = defaults[20]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 2, 3, 12, 13, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[20][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 3, 4, 12, 13, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Incr. Scale ---------------------
    pf_type = params[21][0]
    name = params[21][1]
    desc = params[21][2]
    def_val = defaults[21]
    
    label = gtk.Label(desc)
    label.set_use_underline(True)
    label.set_alignment(0.0, 0.5)
    table.attach(label, 4, 5, 12, 13, xoptions=gtk.FILL)
    label.show()
    
    wid = _edit_mapping[pf_type](def_val, params[21][4])
    label.set_mnemonic_widget(wid)
    table.attach(wid, 5, 6, 12, 13, yoptions=0)
    #tooltips.set_tip(wid, desc, None)
    wid.show()
    wid.desc = desc
    edit_wids.append(wid)

# Separators

    # Horizontal Separator 1  ---------------------
    separator = gtk.HSeparator()
    table.attach(separator, 0, 12, 1, 2, xoptions=gtk.FILL)
    separator.show()
    
    # Horizontal Separator 2 ---------------------
    separator = gtk.HSeparator()
    table.attach(separator, 1, 12, 4, 5, xoptions=gtk.FILL)
    separator.show()

    # Horizontal Separator 3 ---------------------
    separator = gtk.HSeparator()
    table.attach(separator, 1, 12, 8, 9, xoptions=gtk.FILL)
    separator.show()

    #rearrange widget list to match param order
    r = [] # rearranged list
    r.append(edit_wids[0]) #Path mode
    r.append(edit_wids[1]) #X limit(px):
    r.append(edit_wids[2]) #Y limit(px):
    r.append(edit_wids[6]) #X formula
    r.append(edit_wids[7]) #Y formula
    r.append(edit_wids[3]) #Num Points:
    r.append(edit_wids[8]) #X Pasted points
    r.append(edit_wids[4]) #Seed:
    r.append(edit_wids[5]) #Scale
    r.append(edit_wids[9]) #Reverse path
    r.append(edit_wids[10]) #Multiple strokes
    r.append(edit_wids[11]) #Copies
    r.append(edit_wids[12]) #Offset X
    r.append(edit_wids[13]) #Offset Y
    r.append(edit_wids[14]) #Alternate
    r.append(edit_wids[15]) #Rotation
    r.append(edit_wids[16]) #Pivot Type
    r.append(edit_wids[17]) #Pivot X
    r.append(edit_wids[18]) #Pivot Y
    r.append(edit_wids[19]) #Filp Flop
    r.append(edit_wids[20]) #Flip Type
    r.append(edit_wids[21]) #Incr. Scale

    edit_wids = r

##    names = ''
##    for wid in edit_wids:
##        names=names+','+wid.desc
        
##    pdb.gimp_message(names)

# Widgets Interaction ---------------------------
    def callback_toggle1(widget, data=None):
        val = edit_wids[0].get_active()
        if val !=4:
            edit_wids[3].set_sensitive(0)
            edit_wids[4].set_sensitive(0)
            edit_wids[6].set_sensitive(0)
            edit_wids[9].set_sensitive(0)
            edit_wids[10].set_sensitive(0)
            edit_wids[11].set_sensitive(0)
            edit_wids[12].set_sensitive(0)
            edit_wids[13].set_sensitive(0)
            edit_wids[14].set_sensitive(0)
            edit_wids[15].set_sensitive(0)
            edit_wids[16].set_sensitive(0)
            edit_wids[17].set_sensitive(0)
            edit_wids[18].set_sensitive(0)
            edit_wids[19].set_sensitive(0)
            edit_wids[20].set_sensitive(0)
            edit_wids[21].set_sensitive(0)



        else:
            edit_wids[3].set_sensitive(1)
            edit_wids[4].set_sensitive(1)
            edit_wids[6].set_sensitive(1)
            edit_wids[9].set_sensitive(1)
            edit_wids[10].set_sensitive(1)
            

            if edit_wids[10].get_value() == True:
                edit_wids[11].set_sensitive(1)
                edit_wids[12].set_sensitive(1)
                edit_wids[13].set_sensitive(1)
                edit_wids[14].set_sensitive(1)
                edit_wids[15].set_sensitive(1)
                edit_wids[16].set_sensitive(1)
                edit_wids[17].set_sensitive(1)
                edit_wids[18].set_sensitive(1)
                edit_wids[19].set_sensitive(1)
                edit_wids[20].set_sensitive(1)
                edit_wids[21].set_sensitive(1)

    def callback_toggle2(widget, data=None):

        val = edit_wids[10].get_value()
        if val == False:
            edit_wids[11].set_sensitive(0)
            edit_wids[12].set_sensitive(0)
            edit_wids[13].set_sensitive(0)
            edit_wids[14].set_sensitive(0)
            edit_wids[15].set_sensitive(0)
            edit_wids[16].set_sensitive(0)
            edit_wids[17].set_sensitive(0)
            edit_wids[18].set_sensitive(0)
            edit_wids[19].set_sensitive(0)
            edit_wids[20].set_sensitive(0)
            edit_wids[21].set_sensitive(0)

        else:
            edit_wids[11].set_sensitive(1)
            edit_wids[12].set_sensitive(1)
            edit_wids[13].set_sensitive(1)
            edit_wids[14].set_sensitive(1)
            edit_wids[15].set_sensitive(1)
            edit_wids[16].set_sensitive(1)
            edit_wids[17].set_sensitive(1)
            edit_wids[18].set_sensitive(1)
            edit_wids[19].set_sensitive(1)
            edit_wids[20].set_sensitive(1)
            edit_wids[21].set_sensitive(1)



##
##    #get installed fonts number
##    num_fonts, font_list = pdb.gimp_fonts_get_list("")
##
##    def callback_limitsToggle(widget, data=None):
##        val = edit_wids[2].get_active()
##        if val==0:
##            edit_wids[3].set_sensitive(0)
##            edit_wids[4].set_sensitive(0)
##        else:
##            edit_wids[3].set_sensitive(1)
##            edit_wids[4].set_sensitive(1)
##
##    def callback_customToggle(widget, data=None):
##        val = edit_wids[5].get_active()
##        if val==0:
##            edit_wids[6].set_sensitive(0)
##        else:
##            edit_wids[6].set_sensitive(1)
##
##    def callback_setMin(widget, data=None):
##        limit = edit_wids[4].get_value()
##        edit_wids[3].set_range(1,limit)
##        if edit_wids[3].get_value()>= limit:
##            edit_wids[3].set_value(limit)
##
##    def callback_textToggle(widget, data=None):
##        val = edit_wids[15].get_active()
##        if val==0:
##            edit_wids[16].set_sensitive(0)
##        else:
##            edit_wids[16].set_sensitive(1)
##
##
##    handler_1 = edit_wids[4].connect('output',callback_setMin,None)
##    handler_2 = edit_wids[5].connect('changed',callback_customToggle,None)
##    handler_3 = edit_wids[2].connect('changed',callback_limitsToggle,None)
##    handler_4 = edit_wids[15].connect('changed',callback_textToggle,None)

    handler_1 = edit_wids[0].connect('changed',callback_toggle1,None)
    handler_2 = edit_wids[10].connect('toggled',callback_toggle2,None)
    
    # Dialog DEFAULTS:
    
    #set range for font range maximum limit 
##    edit_wids[4].set_range(1,num_fonts+1)

    #Disable font range limit and 'custom' spinners:
##    if edit_wids[2].get_active() == 0:
##        edit_wids[3].set_sensitive(0)
##        edit_wids[4].set_sensitive(0)        
##
##    if edit_wids[5].get_active() == 0:
##         edit_wids[6].set_sensitive(0)



# TABLE POPULATION LOOP [from original code]
##    for i in range(len(params)):
##        pf_type = params[i][0]
##        name = params[i][1]
##        desc = params[i][2]
##        def_val = defaults[i]
##
##        label = gtk.Label(desc)
##        label.set_use_underline(True)
##        label.set_alignment(0.0, 0.5)
##        table.attach(label, 1, 2, i, i+1, xoptions=gtk.FILL)
##        label.show()
##
##        if pf_type in (PF_SPINNER, PF_SLIDER, PF_RADIO, PF_OPTION):
##            wid = _edit_mapping[pf_type](def_val, params[i][4])
##        else:
##            wid = _edit_mapping[pf_type](def_val)
##
##        label.set_mnemonic_widget(wid)
##        
##        table.attach(wid, 2,3, i,i+1, yoptions=0)
##
##        if pf_type != PF_TEXT:
##            #tooltips.set_tip(wid, desc, None)
##        else:
##            #Attach tip to TextView, not to ScrolledWindow
##            #tooltips.set_tip(wid.view, desc, None)
##        wid.show()
##
##        wid.desc = desc
##        edit_wids.append(wid)
##

# END OF TABLE POPULATION LOOP

    progress_vbox = gtk.VBox(False, 6)
    vbox.pack_end(progress_vbox, expand=False)
    progress_vbox.show()

    progress = gimpui.ProgressBar()
    progress_vbox.pack_start(progress)
    progress.show()

#    progress_label = gtk.Label()
#    progress_label.set_alignment(0.0, 0.5)
#    progress_label.set_ellipsize(pango.ELLIPSIZE_MIDDLE)

#    attrs = pango.AttrList()
#    attrs.insert(pango.AttrStyle(pango.STYLE_ITALIC, 0, -1))
#    progress_label.set_attributes(attrs)

#    progress_vbox.pack_start(progress_label)
#    progress_label.show()

    #tooltips.enable()
    dialog.show()
    gtk.main()

    if hasattr(dialog, 'res'):
        res = dialog.res
        dialog.destroy()
        return res
    else:
        dialog.destroy()
        raise CancelError

# ~~~~~~~~~~~~~~~~~~~~~~~~~~ PLUG-IN CODE ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# Vector Path
# Python plug-in for GIMP 2.7/2.8
# version 2.0 BETA2
# PLEASE DOWNLOAD THE FINAL VERSION FROM MY WEBSITE WHEN AVAILABLE!
# 
# This is a generator script, produces vector path based
# on series of modes / settings.
# 
#
#2012-June
# Andrei Roslovtsev
# www.bytes-and-pixels.com
# andrei[AT]bytes-and-pixels.com

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

import sys,random as r
from math import *

def draw_path(image,drawable,path_mode,x_limit,y_limit,x_f,y_f,num_points,pasted,seed,
              scale,reverse,multiple,copies,offset_x,offset_y,alternate,
              rotation,pivot_type,pivot_x,pivot_y,flip_flop,flip_type, incr_scale):

    # Variables
    num_coords = num_points*6  # number of values in array
    
    i=0   # main iterator: equals to number of items in array
    j=1   # switch to identify CAC pattern
    x=0   # x coord
    y=0   # y coord
    phi = 1.618
    phi_inv = 0.618
    pi = 3.14159265
    coords=[]   # list of coordinates
    coords_rev=[] # reverse list of coordinates
    scale = float(scale)/100
    incr_scale = float(incr_scale)/100

    r.seed(seed)
    if path_mode == 0:
        while i<num_coords:
            x=r.randint(0,x_limit)
            coords.append(x)
            y=r.randint(0,y_limit)
            coords.append(y)
            i=i+1

    if path_mode == 1:
        while i<num_coords:
            if j==1:
                x=r.randint(0,x_limit)

                coords.append(x)
                y=r.randint(0,y_limit)
                coords.append(y)
                i=i+1
                j=j+1
                continue

            if j==2:
                x=r.randint(0,x_limit)
                coords.append(x)
                y=r.randint(0,y_limit)
                coords.append(y)
                i=i+1
                j=j+1
                continue

            if j==3:
                #      anchor pos |difference between anchor & cp1 |
                x=(coords[i*2-2])+((coords[i*2-2])-(coords[i*2-4]))
                coords.append(x)
                y=(coords[i*2-1])+((coords[i*2-1])-(coords[i*2-3]))
                coords.append(y)
                i=i+1
                j=1

    if path_mode == 2:
        while i<num_points:
            
                x=r.randint(0,x_limit)
                y=r.randint(0,y_limit)
                coords.append(x)
                coords.append(y)
                coords.append(x)
                coords.append(y)
                coords.append(x)
                coords.append(y)
                i=i+1
                continue

    if path_mode == 3:
        x_mem = 0
        y_mem = 0
        x_prev = 0
        y_prev = 0
        axis = 'x'
        while i < num_coords/6: #get number of points
            if i==0:
                x_mem = r.randint(0,x_limit)
                y_mem = r.randint(0,y_limit)

            if i>0 and axis == 'x':
                x_mem = x_mem
                y_mem = r.randint(0,y_limit)

            if i>0 and axis == 'y':
                x_mem = r.randint(0,x_limit)
                y_mem = y_mem

            #point coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent1 coords
            coords.append(x_mem)
            coords.append(y_mem)
            #tangent2 coords
            coords.append(x_mem)
            coords.append(y_mem)

            coords_rev.reverse()
            coords_rev.append(y_mem)
            coords_rev.append(x_mem)
            coords_rev.append(y_mem)
            coords_rev.append(x_mem)
            coords_rev.append(y_mem)
            coords_rev.append(x_mem)
            coords_rev.reverse()

            #switch axes
            if axis == 'x':
                axis = 'y'
            else:
                axis = 'x'
                
            x_prev = x_mem
            y_prev = y_mem
            
            i=i+1

    if path_mode == 4:
        x_mem = 0
        y_mem = 0

        # if user pastes point coordinates list from Formula Viewer,
        # go straight ahead and generate the path,
        # no need to process formulae

        
        if pasted != "" and isList(pasted):
            pasted = eval(pasted)
            num_coords = len(pasted)*6
            while i < len(pasted):
                coords.append(pasted[i][0])
                coords.append(pasted[i][1])
                coords.append(pasted[i][0])
                coords.append(pasted[i][1])
                coords.append(pasted[i][0])
                coords.append(pasted[i][1])

                if reverse:
                    coords_rev.reverse()
                    coords_rev.append(pasted[i][1])
                    coords_rev.append(pasted[i][0])
                    coords_rev.append(pasted[i][1])
                    coords_rev.append(pasted[i][0])
                    coords_rev.append(pasted[i][1])
                    coords_rev.append(pasted[i][0])
                    coords_rev.reverse()

                i=i+1

        else:
            while i < num_coords/6: #get number of points

                x_mem = eval(x_f)
                y_mem = eval(y_f)

                #point coords
                coords.append(x_mem)
                coords.append(y_mem)
                #tangent1 coords
                coords.append(x_mem)
                coords.append(y_mem)
                #tangent2 coords
                coords.append(x_mem)
                coords.append(y_mem)

                if reverse:
                    
                    coords_rev.reverse()
                    coords_rev.append(y_mem)
                    coords_rev.append(x_mem)
                    coords_rev.append(y_mem)
                    coords_rev.append(x_mem)
                    coords_rev.append(y_mem)
                    coords_rev.append(x_mem)
                    coords_rev.reverse()
                    
                i=i+1

    # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

    if multiple and path_mode == 4:
        #Duplicate path

        # set rotation point to image center if selected
        if pivot_type == 0:
            pivot_x = image.width/2
            pivot_y = image.height/2
        
        flip = False
        alt = False

        vObj = pdb.gimp_vectors_new(image, 'path_')
        pdb.gimp_image_add_vectors(image, vObj, 100)
        for i in range(int(copies)):
            tmp = pdb.gimp_vectors_stroke_new_from_points(vObj, 0,
                                                    num_coords,coords, 0)

            if scale <> 1:
                pdb.gimp_vectors_stroke_scale(vObj, tmp, scale, scale)

            if flip_flop:
                if flip_type == 0:
                    flip_axis = image.width/2
                else:
                    flip_axis = image.height/2
                    
                if flip == False:
                    pdb.gimp_vectors_stroke_flip(vObj, tmp, flip_type, flip_axis)
                    flip=True
                else:
                    flip=False
              
            if offset_y != 0 or offset_x !=0:
                if not alternate:
                    pdb.gimp_vectors_stroke_translate(vObj, tmp, offset_x*(i+1), offset_y*(i+1))
                else:
                    if alt == False:
                        pdb.gimp_vectors_stroke_translate(vObj, tmp, offset_x/2*(i+1), offset_y/2*(i+1))
                        alt = True
                    else:
                        pdb.gimp_vectors_stroke_translate(vObj, tmp, offset_x/2*(i+1)*-1, offset_y/2*(i+1)*-1)
                        alt = False
                        
                    

            if rotation != 0:
                pdb.gimp_vectors_stroke_rotate(vObj, tmp, pivot_x, pivot_y, rotation*(i+1))

            if incr_scale <>1:
                pdb.gimp_vectors_stroke_scale(vObj, tmp, pow(incr_scale,(i+1)), pow(incr_scale,(i+1)))

            
        if reverse:
            
            flip = False
            alt = False

            vObj2 = pdb.gimp_vectors_new(image, 'path_reverse_')
            pdb.gimp_image_add_vectors(image, vObj2, 100)
            for i in range(int(copies)):
                tmp = pdb.gimp_vectors_stroke_new_from_points(vObj2, 0,
                                                        num_coords,coords_rev, 0)

                if scale <> 1:
                    pdb.gimp_vectors_stroke_scale(vObj, tmp, scale, scale)
                    
                if flip_flop:
                    if flip_type == 0:
                        flip_axis = image.width/2
                    else:
                        flip_axis = image.height/2
                        
                    if flip == False:
                        pdb.gimp_vectors_stroke_flip(vObj2, tmp, flip_type, flip_axis)
                        flip=True
                    else:
                        flip=False
                  
                if offset_y != 0 or offset_x !=0:
                    if not alternate:
                        pdb.gimp_vectors_stroke_translate(vObj2, tmp, offset_x*(i+1), offset_y*(i+1))
                    else:
                        if alt == False:
                            pdb.gimp_vectors_stroke_translate(vObj2, tmp, offset_x/2*(i+1), offset_y/2*(i+1))
                            alt = True
                        else:
                            pdb.gimp_vectors_stroke_translate(vObj2, tmp, offset_x/2*(i+1)*-1, offset_y/2*(i+1)*-1)
                            alt = False
                            
                if rotation != 0:
                    pdb.gimp_vectors_stroke_rotate(vObj2, tmp, pivot_x, pivot_y, rotation*(i+1))

                if incr_scale <>1:
                    pdb.gimp_vectors_stroke_scale(vObj2, tmp, pow(incr_scale,(i+1)), pow(incr_scale,(i+1)))



    else:
        vObj = pdb.gimp_vectors_new(image, 'path_')
        pdb.gimp_image_add_vectors(image, vObj, 100)
        stroke_id = pdb.gimp_vectors_stroke_new_from_points(vObj, 0,
                                                            num_coords,coords,
                                                            0)
        pdb.gimp_vectors_stroke_scale(vObj, stroke_id, scale, scale)

        if reverse and path_mode == 4:
            vObj2 = pdb.gimp_vectors_new(image, 'path_reverse_')
            pdb.gimp_image_add_vectors(image, vObj2, 100)
            stroke_id = pdb.gimp_vectors_stroke_new_from_points(vObj2, 0,
                                                                num_coords,coords_rev,
                                                                0)
            pdb.gimp_vectors_stroke_scale(vObj2, stroke_id, scale, scale)
            
#--------------------------------------------------------------------
def isList(data):
    try:
        tmp = eval(data)
        if type(tmp) is list:
            return True
        else:
            pdb.gimp_message('''Pasted data is not a valid list.
Using formula fields instead.''')
            return False
    except:
        pdb.gimp_message('''Pasted data is not a valid list.
Using formula fields instead.''')
        return False
    
def f_viewer_launch():
    #this works but plugin dialog is not showing until this window is closed:
    #import formula_viewer
    #formula_viewer.run()

    path = gimp.plug_in_directory
    
    #this works but multiple copies a spawned when re-showing
    #the plug-in dialog (not necessarilly a bad thing):
    import os
    try:
        os.startfile(path+'\\python\\'+'formula_viewer2.pyw')
    except:
        pass
    
#-----------------------------------------------------------------
register(
    "Vector_path_2",
    N_("Create a vector path"),
    "Create a vector path",
    "Andrei Roslovtsev",
    "www.bytes-and-pixels.com",
    "2012",
    "_Vector Path 2 [Beta]",
    "RGB*, GRAY*",
    [
        (PF_IMAGE, "image",       "Input image", None),
        (PF_DRAWABLE, "drawable", "Input drawable", None),
        (PF_OPTION, "path_mode", "Path Mode:", 4, ["Random","Random Smooth",
                                                   "Random Linear","Perpendicular","Formula"]),
        (PF_SPINNER, "x_limit", "X limit(px):", 400, (50, 2000, 10)),
        (PF_SPINNER, "y_limit", "Y limit(px):", 400, (50, 2000, 10)),
        (PF_TEXT, "x_f", "X formula:", "((i*0.5)*5)+(sin(i*0.125)*100)"),
        (PF_TEXT, "y_f", "Y formula:", "100+(sin(i*0.25)*20)+(cos(i*1)*0.25)"),
        (PF_SPINNER, "num_points", "Points:", 500, (2, 1000000, 1)),
        (PF_TEXT, "pasted", "Paste Points:", ""),
        (PF_SPINNER, "seed", "Seed:", 1000, (1, 2000, 1)),
        (PF_SPINNER, "scale", "Scale (%):", 100, (1, 1000, 1)),
        (PF_TOGGLE, "reverse", "Reverse Path:", 1),
        (PF_TOGGLE, "multiple", "Multiple Strokes:", 0),
        (PF_SPINNER, "copies", "Copies:", 10, (2, 1000, 1)),
        (PF_SPINNER, "offset_x", "Offset X:", 0, (-1000, 1000, 1)),
        (PF_SPINNER, "offset_y", "Offset Y:", 10, (-1000, 1000, 1)),
        (PF_TOGGLE, "alternate", "Alternate(+/-):", 0),
        (PF_SPINNER, "rotation", "Rotation:", 0, (-360, 360, 1)),
        (PF_OPTION, "pivot_type", "Pivot Type:", 0, ["Image Center","Custom"]),
        (PF_SPINNER, "pivot_x", "Pivot X:", 0, (0, 1024, 1)),
        (PF_SPINNER, "pivot_x", "Pivot Y:", 0, (0, 1024, 1)),
        (PF_TOGGLE, "flip_flop", "Flip Flop:", 0),
        (PF_OPTION, "flip_type", "Flip Type:", 1, ["Horizontal","Vertical"]),
        (PF_SPINNER, "incr_scale", "Incr. Scale (%):", 100, (1, 1000, 1)),
    ],
    [],
    draw_path,
    #menu="<Image>/File/Create/Buttons",
    menu="<Image>/Filters/Bytes/vvv",
    domain=("gimp20-python", gimp.locale_directory),
    on_run=f_viewer_launch
    )

main()
